package com.rjconsultores.integracaoreceitadespesa.entidades;

import java.util.List;

import org.apache.commons.lang.StringUtils;

public class DespesaReceitaComporte extends DespesaReceita {

	protected String numeroEstabelecimento;
	protected String codigoAutorizacao;
	protected String cantParcelas = "";
	protected String numfoliosistema = "";
	protected String txId = "";
	
	@Override
	public void preencheLinha(List<String> rows) {
		StringBuilder sb = new StringBuilder();
		sb.append(dataLancamento);
		sb.append(codigoEmpresa);
		sb.append(codigoFilial);
		sb.append(localArrecadacao.toUpperCase());
		sb.append(numeroDaGuia);
		sb.append(dataMovimento);
		sb.append(usuarioGlobus);
		sb.append(turno);
		sb.append(codigoReceitaDespesa);
		sb.append(identificadorReceitaDespesa.toUpperCase());
		sb.append(valorLancamento);
		sb.append(numeroContratoTurismo);
		sb.append(numeroReciboTurismo);
		sb.append(getFormaPagamentoTurismo());
		sb.append(getTipoPagamentoTurismo());
		sb.append(StringUtils.rightPad("", 80, " "));
		sb.append(StringUtils.rightPad(numeroEstabelecimento, 10, "0").substring(0,10));
		sb.append(StringUtils.rightPad(codigoAutorizacao, 6, "0").substring(0,6));
		sb.append(StringUtils.rightPad("", 16, " "));
		sb.append(StringUtils.rightPad("", 3, "0"));
		sb.append(StringUtils.leftPad(formaPagamentoId, 2, "0"));
		sb.append(cantParcelas);
		sb.append(numfoliosistema);
		sb.append(txId);
		sb.append(finalLinha);
		sb.append(System.getProperty("line.separator"));
		rows.add(sb.toString());
	}

	public String getNumeroEstabelecimento() {
		return numeroEstabelecimento;
	}

	public void setNumeroEstabelecimento(String numeroEstabelecimento) {
		this.numeroEstabelecimento = StringUtils.rightPad(numeroEstabelecimento != null ? numeroEstabelecimento : "", 10, " ");
	}

	public String getCodigoAutorizacao() {
		return codigoAutorizacao;
	}

	public void setCodigoAutorizacao(String codigoAutorizacao) {
		this.codigoAutorizacao =  StringUtils.rightPad(codigoAutorizacao != null ? truncStr(codigoAutorizacao, 22) : "", 22, "0");
	}

	public String getCantParcelas() {
		return cantParcelas;
	}

	public void setCantParcelas(String cantParcelas) {
		this.cantParcelas = StringUtils.isNotEmpty(cantParcelas) ? StringUtils.leftPad(cantParcelas, 4,"0") : "    ";
	}

	public String getNumfoliosistema() {
		return numfoliosistema;
	}

	public void setNumfoliosistema(String numfoliosistema) {
		this.numfoliosistema = StringUtils.leftPad(numfoliosistema != null ? numfoliosistema : "", 16, "");
	}

	public String getTxId() {
		return txId;
	}

	public void setTxId(String txId) {
		this.txId = StringUtils.leftPad(txId != null ?  truncStr(txId, 36) : "", 35, "");
	}
		
}
